from http.client import HTTPSConnection
from email.parser import HeaderParser
from io import StringIO
RAW_PEP_URL = "raw.githubusercontent.com"

class PEPNotFound(Exception):
    pass

def pep_metadata(pep_number):
    pep_number = str(pep_number).zfill(4)
    
    for extension in ("rst", "txt"):
        conn = HTTPSConnection(RAW_PEP_URL)
        conn.request("GET", f"/python/peps/master/pep-{pep_number}.{extension}")
        response = conn.getresponse()
        
        if response.status != 200:
            continue
        result = response.read().decode()
        if result:
            break
    else:
        return None
    
    buffer = StringIO(result)
    pep_header = HeaderParser().parse(buffer)
    
    title = pep_header["Title"]
    status = pep_header.get("Status", "unknown")
    authors = []

    for author in pep_header.get("Author", "").split(","):
        *author, mail = author.split()
        author = " ".join(author)
        authors.append((author, mail))
    
    return title, status, authors
